/*
 * Copyright FinanceScout24 AG 
 *
 * $author: $
 *
 * $Date: 2004/12/03 13:18:07 $
 *
 * $Archive: $
 *
 * $Log: DeployParRemoteTask.java,v $
 * Revision 1.2  2004/12/03 13:18:07  ckolb
 * Remote-Deployment: Ant-Task und DeploymentServiceBean
 *
 * Revision 1.1  2004/12/02 18:00:51  ckolb
 * Remote-Deployment: Ant-Task und DeploymentServiceBean
 *
 */
package org.jbpm.ejb.ant;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Properties;

import javax.naming.Context;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.types.FileSet;
import org.jbpm.ejb.DeploymentServiceRemote;
import org.jbpm.ejb.EjbDeploymentException;
import org.jbpm.ejb.JbpmEjbServiceLocator;

/**
 * @author CKolb
 */
public class DeployParRemoteTask extends MatchingTask
{
    
    /**
     * 
     */
    public DeployParRemoteTask()
    {
        super();
    }
    

    private String namingproviderurl = null;
    private String namingfactoryinitial = null;

    public void setNamingfactoryinitial(String namingFactoryInitial)
    {
        this.namingfactoryinitial = namingFactoryInitial;
    }


    public void setNamingproviderurl(String namingProviderUrl)
    {
        this.namingproviderurl = namingProviderUrl;
    }

    private List fileSets = new LinkedList();

    public void addFileset(FileSet fileSet)
    {
        fileSets.add(fileSet);
    }


    public void execute() throws BuildException
    {
        try
        {
            Iterator iter = getFiles().iterator();
            while (iter.hasNext())
            {
                File file = (File) iter.next();
                deploy(file);
            }

        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new RuntimeException("couldn't deploy process archives : " + e.getMessage(), e);
        }
    }

    /**
     * @param file
     * @throws FileNotFoundException
     * @throws IOException
     */
    private void deploy(File file) throws FileNotFoundException, IOException
    {
        log("Deploying process archive " + file + ".");
        FileInputStream fis = new FileInputStream(file);
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        int b = 0;
        while ((b = fis.read()) != -1)
        {
            bos.write(b);
        }
        bos.flush();
        byte[] parFile = bos.toByteArray();
        bos.close();
        deploy(parFile);
    }

    private void deploy(byte[] parFile) throws BuildException
    {
        try
        {
            JbpmEjbServiceLocator serviceLocator = null;
            if ( (this.namingfactoryinitial != null) && (this.namingproviderurl != null))
            {
                Properties properties = new Properties();
                properties.setProperty(Context.PROVIDER_URL, this.namingproviderurl);
                properties.setProperty(Context.INITIAL_CONTEXT_FACTORY, this.namingfactoryinitial);
                serviceLocator = new JbpmEjbServiceLocator(properties);
            }
            else
            {
                serviceLocator = new JbpmEjbServiceLocator();
            }
            
            DeploymentServiceRemote deployService = serviceLocator.getDeploymentServiceRemote();
            deployService.deploy(parFile);
            serviceLocator.release(deployService);
        }
        catch (EjbDeploymentException e)
        {
            e.printStackTrace();
            throw new BuildException("Could not deploy par file.", e);
        }
        catch (RemoteException e)
        {
            e.printStackTrace();
            throw new BuildException("Could not deploy par file.", e);
        }

    }

    private List getFiles()
    {
        List files = new LinkedList();
        for (Iterator i = fileSets.iterator(); i.hasNext();)
        {

            FileSet fs = (FileSet) i.next();
            DirectoryScanner ds = fs.getDirectoryScanner(getProject());

            String[] dsFiles = ds.getIncludedFiles();
            for (int j = 0; j < dsFiles.length; j++)
            {
                File f = new File(dsFiles[j]);
                if (!f.isFile())
                {
                    f = new File(ds.getBasedir(), dsFiles[j]);
                }

                files.add(f);
            }
        }

        return files;
    }
}